#ifndef SSTM_H
#define SSTM_H

#include "SsPreCompile.h" //QTextDecoder

#include "tunnelinfodialog.h" //TunnelInfoDialog
#include "ErrorInfoDialog.h" //ErrorInfoDialog
#include "SstmSettingDialog.h" //SstmSettingDialog
#include "SstmTtsClient.h" //SstmTtsClient
#include "TunnelStatus.h" //TunnelStatus
#include "Tunnel.h" //Tunnel

namespace Ui {
class Sstm;
}

/*!
 * \brief The Sstm class 栖身。隧道管理器。
 */
class Sstm : public QMainWindow
{
    Q_OBJECT

public:
    explicit Sstm(QWidget *parent = 0);
    ~Sstm();
    
private:
    void startAutoStartTunnels(); //!<启动所有应当自动启动的隧道。
    QList<Tunnel*> tunnelList; //!<隧道对象列表。
    void restartTunnelOjbect(int CrtIdx); //!<restart 隧道对象。
    void startTunnelOjbect(int CrtIdx); //!<启动隧道对象。
    void reportTunnelStarted(); //!<报告隧道已启动。
    QMap<int,TunnelStatus> tunnelStatusList; //!<隧道状态列表。
    QMap<QProcess*,int> processTunnelInfoIndexMap; //!<进程与隧道下标编号之间的映射。
    QMenu TrayMn; //!<托盘图标的菜单。
    void AsesShow(QSystemTrayIcon::ActivationReason ActRsn); //!<点击左键时，显示主窗口。
    QSystemTrayIcon TrayIcn; //!<托盘图标。
    void showTray(); //!<显示托盘图标。
    SstmTtsClient ttsClient; //!<TTS客户端。
    SstmSettingDialog stngDlg; //!<设置对话框。
    ErrorInfoDialog errIfoDlg; //!<错误信息对话框。
    TunnelInfoDialog editTunnelDialog; //!<用来编辑隧道信息的对话框。
    QString SshCmd="ssh"; //!<ssh命令。
    void loadConfig(); //!<载入配置信息。
    QVariantList TnlLstVrnt; //!<隧道信息列表。
    Ui::Sstm *ui; //!<用户界面。
    TunnelInfoDialog newTunnelInfoDialog; //!<新建隧道信息对话框。

private slots:
    void restartTunnel(); //!<Restart tunnel.
    void updateButtonStatus(int currentRow); //!<更新按钮的状态。
    void asesRestart(); //!<进程出错，则评估一下是否要重启。
    void SaveConfig(); //!<保存配置信息。
    void quit(); //!<退出。
    void showSettingDialog(); //!<显示设置对话框。
    void reportTunnelError(QProcess::ProcessError err); //!<进程出错，则报告错误。
    void reportTunnelFinish(int extCd); //!<隧道进程结束，则报告状态。
    void EditTunnel(); //!<输入完了隧道信息之后，修改隧道。
    void PopEditTunnelDialog(); //!<弹出编辑隧道信息对话框。
    void StartTunnel(); //!<启动隧道。
    void PopNewTunnelDialog(); //!<弹出“新隧道”对话框。
    void AddTunnel(); //!<输入完了隧道信息之后，添加隧道。
}; //class Sstm : public QMainWindow

#endif // SSTM_H
