#include "SsPreCompile.h" //QInputDialog

#include "SstmSettingDialog.h" //SstmSettingDialog
#include "ui_SstmSettingDialog.h" //SstmSettingDialog

SstmSettingDialog::SstmSettingDialog(QWidget *parent) :QDialog(parent),ui(new Ui::SstmSettingDialog)
{
    ui->setupUi(this);
}

SstmSettingDialog::~SstmSettingDialog()
{
    delete ui;
}

void SstmSettingDialog::changeEvent(QEvent *e)
{
    QDialog::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}








/*!
 * \brief StbSettingDialog::getTtsServerAddress 获取TTS服务器的地址。
 * \return TTS服务器的地址。
 */
QString SstmSettingDialog::getTtsServerAddress()
{
    QString result; //结果。

    result=ui->ttsServerAddresslineEdit->text (); //返回输入框内容。

    return result;
} //QString StbSettingDialog::getTtsServerAddress() //!<获取TTS服务器的地址。

/*!
 * \brief StbSettingDialog::getTtsServerPort 获取TTS服务器的端口号。
 * \return TTS服务器的端口号。
 */
quint16 SstmSettingDialog::getTtsServerPort()
{
    quint16 result=0; //结果。

    result=ui->ttsServerPortspinBox->value (); //结果即为旋转框的值。

    return result;
} //quint16 StbSettingDialog::getTtsServerPort() //!<获取TTS服务器的端口号。

/*!
 * \brief StbSettingDialog::setTtsServerAddress 设置TTS服务器地址。
 * \param ttsServerAddress 要设置的TTS服务器地址。
 */
void SstmSettingDialog::setTtsServerAddress(QString ttsServerAddress)
{
    ui->ttsServerAddresslineEdit->setText (ttsServerAddress); //显示。

    return;
} //void StbSettingDialog::setTtsServerAddress(QString ttsServerAddress) //!<设置TTS服务器地址。

/*!
 * \brief StbSettingDialog::setTtsServerPort 设置TTS服务器的端口号。
 * \param ttsServerPort 要设置的TTS服务器端口号。
 */
void SstmSettingDialog::setTtsServerPort(quint16 ttsServerPort)
{
    ui->ttsServerPortspinBox->setValue (ttsServerPort); //显示。

    return;
} //void StbSettingDialog::setTtsServerPort(quint16 ttsServerPort) //!<设置TTS服务器的端口号。
