#ifndef TUNNEL_H
#define TUNNEL_H

#include "SsPreCompile.h" //QTextDecoder

#include "tunnelinfodialog.h" //TunnelInfoDialog
#include "ErrorInfoDialog.h" //ErrorInfoDialog
#include "SstmSettingDialog.h" //SstmSettingDialog
#include "SstmTtsClient.h" //SstmTtsClient
#include "TunnelStatus.h" //TunnelStatus
#include "TunnelStatusChecker.h" //TunnelStatusChecker

QT_FORWARD_DECLARE_CLASS(TunnelStatusChecker)

/*!
 * \brief The Sstm class 栖身。隧道管理器。
 */
class Tunnel:public QObject
{
    Q_OBJECT

public:
    quint16 getLocalPort(); //!<获取本地端口号。
    void setAutoRestart(bool autoRestartToSet); //!<设置是否要自动重启。
    void kill (); //!<杀死该进程。
    Tunnel(QString CrtSrvrIpToSet,quint16 CrtSrvrPrtToSet,quint16 CrtLclPrtToSet,QString crtUserName); //!<构造隧道对象。
    void start(); //!<启动隧道。
    explicit Tunnel(QObject *parent = 0); //!<构造函数。
    ~Tunnel(); //!<析构函数。
    
    bool getAutoCheckTunnelStatus() const;
    void setAutoCheckTunnelStatus(bool value);

    bool getAutoStart() const;
    void setAutoStart(bool value);

    bool getAutoRestart() const;

private:
    bool autoStart; //!<是否应当自动启动。
    void startTunnelStatusChecker(); //!<启动隧道状态检查器。
    TunnelStatusChecker * tunnelStatusChecker=nullptr; //!<隧道状态检查器。
    bool autoRestart; //!<是否应当自动重启。
    bool autoCheckTunnelStatus=true; //!<是否应当自动检查隧道状态。
    void asesRestart(); //!<进程出错，则评估一下是否要重启。
    QString userName; //!<用户名。
    QString CrtSrvrIp; //!<服务器IP或主机名。
    quint16 CrtSrvrPrt; //!<服务器端口号。
    quint16 CrtLclPrt; //!<本地端口号。
    void connectSignals(); //!<连接信号槽。
    QProcess CrtPrc; //!<用来运行SSH隧道的进程。
    QTextDecoder * StdErrdecoder; //!<标准错误流的字符编码解码器。
    QTextDecoder * decoder; //!<字符编码解码器。
    QString SshCmd="ssh"; //!<ssh命令。
    TunnelInfoDialog newTunnelInfoDialog; //!<新建隧道信息对话框。

private slots:
    void ShowAptOutputStdErr(); //!<隧道进程有标准错误流输出，则显示。
    void reportTunnelFinish(int extCd); //!<隧道进程结束，则报告状态。
    void reportStdOut(); //!<有输出内容，则报告。
}; //class Sstm : public QMainWindow

#endif // SSTM_H
