#ifndef TUNNELSTATUSCHECKER_H
#define TUNNELSTATUSCHECKER_H

#include "SsPreCompile.h" //QNetworkProxy

#include "Tunnel.h" //Tunnel

QT_FORWARD_DECLARE_CLASS(Tunnel)

/*!
 * \brief The TunnelStatusChecker class 隧道状态检查器。
 */
class TunnelStatusChecker : public QObject
{
    Q_OBJECT

public:
    void setTunnel(Tunnel * CrtPrc); //!<设置隧道。
    void startCheck(); //!<开始检查。
    explicit TunnelStatusChecker(QObject *parent = 0);

private:
    void setLocalTunnelPort(quint16 localTunnelPort2Set); //!<设置隧道在本地的端口号。
    Tunnel * tunnelToCheck; //!<要检查的隧道。
    QNetworkProxy smtPrxyObj; //!<智能代理。
    void reportCommitTextError(QNetworkReply::NetworkError code); //!<请求出错，则报告出错。
    void parseCommitTextReply(); //!<请求结束，则处理结果。
    QNetworkAccessManager networkAccessManager; //!<网络访问管理器。
    void checkTunnelStatus(); //!<启动一次检查。
    QTimer statusCheckTimer; //!<状态检查定时器。
    void initializeMemberObjects(); //!<初始化成员对象。
    void connectSignals(); //!<连接信号。
}; //class TunnelStatusChecker : public QObject

#endif // TUNNELSTATUSCHECKER_H
